spool MunDat
/* 

Autor: Lic. Guillermo Cherencio

Implementacion DER
Programacion Aplicacion
Universidad Nacional de Lujan

Forma de uso:

SQL> start <path>\MunDat.sql   (antes correr Mundial.sql)

Creo datos validos e invalidos
para la Implementacion del enunciado DER del Mundial de Futbol
Ejercicio Nro. 10

Formato Gral. de este script:

<< SETEOS DE AMBIENTE/PARAMETROS REQUERIDOS PARA LA EJECUCION >>

<< INSERTO DATOS CORRECTOS >>

<< INSERTO DATOS INCORRECTOS >>

En MunDat.lst queda la salida de este script.

*/
/* Sets para la sesion actual */
clear buffer
set serveroutput on
set verify off
set termout on
ALTER SESSION SET NLS_DATE_FORMAT = 'dd/mm/yyyy'
/

/* Datos de Prueba sobre enunciado DER Mundial de Futbol */

/* 
   Datos validos describiendo un partido entre Arg y Brasil 
   con solo 5 jugadores
*/
INSERT INTO EQUIPO(NOMBRE) VALUES('ARGENTINA');
INSERT INTO EQUIPO(NOMBRE) VALUES('BRASIL');
INSERT INTO EQUIPO(NOMBRE) VALUES('CANADA');
INSERT INTO EQUIPO(NOMBRE) VALUES('COREA');
SELECT * FROM EQUIPO;
INSERT INTO AUTORIDAD VALUES(1,'GONZALEZ, ENRIQUE');
INSERT INTO AUTORIDAD VALUES(2,'PEREZ, JUAN');
INSERT INTO AUTORIDAD VALUES(3,'ESTEVEZ, DARIO');
SELECT * FROM AUTORIDAD;
INSERT INTO PUESTO(IDPUE,DESCRIPCION) VALUES(1,'ARQUERO');
INSERT INTO PUESTO(IDPUE,DESCRIPCION) VALUES(2,'SALGUERO');
INSERT INTO PUESTO(IDPUE,DESCRIPCION) VALUES(3,'VOLANTE DERECHO');
INSERT INTO PUESTO(IDPUE,DESCRIPCION) VALUES(4,'VOLANTE IZQUIERDO');
INSERT INTO PUESTO(IDPUE,DESCRIPCION) VALUES(5,'DELANTERO');
INSERT INTO PUESTO(IDPUE,DESCRIPCION) VALUES(6,'DEFENSA');
SELECT * FROM PUESTO;
INSERT INTO JUGADOR VALUES('BATISTUTA','ARGENTINA');
INSERT INTO JUGADOR VALUES('SIMEONE','ARGENTINA');
INSERT INTO JUGADOR VALUES('VERON','ARGENTINA');
INSERT INTO JUGADOR VALUES('GONZALEZ','ARGENTINA');
INSERT INTO JUGADOR VALUES('CRESPO','ARGENTINA');
INSERT INTO JUGADOR VALUES('CAFU','BRASIL');
INSERT INTO JUGADOR VALUES('PELE','BRASIL');
INSERT INTO JUGADOR VALUES('RONALDO','BRASIL');
INSERT INTO JUGADOR VALUES('TAFAREL','BRASIL');
INSERT INTO JUGADOR VALUES('ALEMAO','BRASIL');
SELECT * FROM JUGADOR;
INSERT INTO PARTIDO VALUES(TO_DATE('18-06-2001'),'ARGENTINA','BRASIL','16:00','18:00',1,2,3);
SELECT * FROM PARTIDO;
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','BATISTUTA',5,2);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','SIMEONE',5,1);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','VERON',5,0);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','GONZALEZ',5,0);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','CRESPO',5,0);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','CAFU',5,0);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','PELE',5,1);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','RONALDO',5,0);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','TAFAREL',1,0);
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','ALEMAO',6,0);

/* Datos Incorrectos para verificar funcionamiento de la base */
INSERT INTO EQUIPO(NOMBRE) VALUES('ALEMANIA');
INSERT INTO JUGADOR VALUES('MITCHELL','ALEMANIA');
/* Intento asociar a Mitchell al partido entre Arg y Bra */
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','MITCHELL',5,0);

/* Intento que Brasil juegue con Argentina el 18-06-2001 */
INSERT INTO PARTIDO VALUES(TO_DATE('18-06-2001'),'BRASIL','ARGENTINA','16:00','18:00',1,2,3);
/* Intento que Brasil juegue con Alemania el 18-06-2001 */
INSERT INTO PARTIDO VALUES(TO_DATE('18-06-2001'),'BRASIL','ALEMANIA','16:00','18:00',1,2,3);
/* Intento que Argentina juegue con Alemania el 18-06-2001 */
INSERT INTO PARTIDO VALUES(TO_DATE('18-06-2001'),'ARGENTINA','ALEMANIA','16:00','18:00',1,2,3);
/* Intento que el Arbitro que dirige Arg - Bra dirija Canada - Corea el mismo dia */
INSERT INTO PARTIDO VALUES(TO_DATE('18-06-2001'),'CANADA','COREA','18:00','20:00',1,2,3);

/* Congelo la lista de jugadores de Argentina */
UPDATE EQUIPO SET OK = 1 WHERE NOMBRE = 'ARGENTINA';
/* Intento agregar a Ortega a la lista de jugadores de Argentina */
INSERT INTO JUGADOR VALUES('ORTEGA','ARGENTINA');

/* Otras pruebas menores de funcionamiento */
/* todas las descripciones deben estar en mayusculas */
INSERT INTO EQUIPO(NOMBRE) VALUES('portugal');
INSERT INTO AUTORIDAD VALUES(4,'Ramirez, Juan');
INSERT INTO PUESTO(IDPUE,DESCRIPCION) VALUES(7,'volante');
INSERT INTO JUGADOR VALUES('Matheus','ALEMANIA');

/* los valores de foreign key deben ser correctos */
/* Intento ingresar un jugador a un equipo que no existe */
INSERT INTO JUGADOR VALUES('MATHEUS','RUMANIA');
/* Intento ingresar un partido con un equipo que no existe */
INSERT INTO PARTIDO VALUES(TO_DATE('20-06-2001'),'ARGENTINA','RUMANIA','16:00','18:00',1,2,3);
INSERT INTO PARTIDO VALUES(TO_DATE('20-06-2001'),'RUMANIA','ARGENTINA','16:00','18:00',1,2,3);
/* Intento ingresar un partido con autoridades que no existen */
INSERT INTO PARTIDO VALUES(TO_DATE('20-06-2001'),'BRASIL','ARGENTINA','16:00','18:00',4,5,6);
/* Agrego un nuevo jugador a Brasil */
INSERT INTO JUGADOR VALUES('CAFURINGA','BRASIL');
/* Agrego a CAFURINGA al partido entre Arg y Bra en un puesto que no existe */
INSERT INTO PAR_JUG VALUES(TO_DATE('18-06-2001'),'ARGENTINA','CAFURINGA',7,0);

clear buffer
COMMIT
/
spool off
/*************** fin *****************************************************/