spool MunPar
/* 

Autor: Lic. Guillermo Cherencio

Implementacion DER
Programacion Aplicacion
Universidad Nacional de Lujan

Forma de uso:

SQL> start <path>\MunPar.sql   (antes ejecutar Mundial.sql,MunDat.sql,MunQry.sql)

Algunos Queries y procesos tipicos sobre
la Implementacion del enunciado DER del Mundial de Futbol
RESPUESTAS 2DO. PARCIAL

Formato Gral. de este script:

<< SETEOS DE AMBIENTE/PARAMETROS REQUERIDOS PARA LA EJECUCION >>

<< EJECUTO QUERIES >>


En MunPar.lst queda la salida de este script.

*/

/* Sets para la sesion actual */
clear buffer
set serveroutput on
set verify off
set termout on
ALTER SESSION SET NLS_DATE_FORMAT = 'dd/mm/yyyy'
/

DROP VIEW POSICION
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

   a) Cul es el promedio gral. de goles, teniendo en 
      cuenta slo los equipos que jugaron?
*/

SELECT AVG(GOL.TGOLES) "PROMEDIO"
FROM ( SELECT PAR.NOMBRE_EQ1, SUM(PJ.GOLES) "TGOLES"
       FROM PARTIDO PAR, PAR_JUG PJ, JUGADOR JG
       WHERE PAR.FECHA = PJ.FECHA AND
             PAR.NOMBRE_EQ1 = PJ.NOMBRE_EQ1 AND
             PJ.NOMBRE = JG.NOMBRE AND
             PAR.NOMBRE_EQ1 = JG.NOMBRE_EQ
       GROUP BY PAR.NOMBRE_EQ1
       UNION
       SELECT PAR.NOMBRE_EQ2, SUM(PJ.GOLES) "TGOLES"
       FROM PARTIDO PAR, PAR_JUG PJ, JUGADOR JG
       WHERE PAR.FECHA = PJ.FECHA AND
             PAR.NOMBRE_EQ1 = PJ.NOMBRE_EQ1 AND
             PJ.NOMBRE = JG.NOMBRE AND
             PAR.NOMBRE_EQ2 = JG.NOMBRE_EQ
       GROUP BY PAR.NOMBRE_EQ2
) GOL
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

   b) En cuntos partidos particip "JUAN PEREZ" 
      como autoridad?
      
*/

SELECT COUNT(*) "CANT. PARTIDOS JUAN PEREZ"
FROM PARTIDO PAR, AUTORIDAD AUT, AUTORIDAD AUTL1, AUTORIDAD AUTL2
WHERE PAR.IDARBITRO = AUT.IDAUT   AND
      PAR.IDLINEA1  = AUTL1.IDAUT AND
      PAR.IDLINEA2  = AUTL2.IDAUT AND
      (AUT.NOMBRE = 'PEREZ JUAN' OR AUTL1.NOMBRE = 'PEREZ JUAN' OR
       AUTL2.NOMBRE = 'PEREZ JUAN')
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

   b) En cuntos partidos particip "JUAN PEREZ" 
      como autoridad?
      
*/

SELECT COUNT(*) "CANT. PARTIDOS JUAN PEREZ"
FROM PARTIDO PAR
WHERE PAR.IDARBITRO = 
      (SELECT IDAUT FROM AUTORIDAD WHERE NOMBRE = 'PEREZ JUAN') OR
      PAR.IDLINEA1  = 
      (SELECT IDAUT FROM AUTORIDAD WHERE NOMBRE = 'PEREZ JUAN') OR
      PAR.IDLINEA2  = 
      (SELECT IDAUT FROM AUTORIDAD WHERE NOMBRE = 'PEREZ JUAN') 
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

   c) Cul fu el partido que comenz ms temprano?
      
*/

SELECT * FROM PARTIDO
WHERE HORA_INICIO = ( SELECT MIN(HORA_INICIO)
                      FROM PARTIDO )
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

   d) Imprimir la tabla de goleadores.  Obviamente
      comenzando por el jugador que ms goles hizo.
      
*/

SELECT GJ.NOMBRE "JUGADOR", SUM(GJ.GOLES) "GOLES"
FROM ( SELECT PJ.NOMBRE, SUM(PJ.GOLES) "GOLES"
       FROM PAR_JUG PJ
       GROUP BY PJ.NOMBRE
       UNION
       SELECT JG.NOMBRE, 0 "GOLES"
       FROM JUGADOR JG ) GJ
GROUP BY GJ.NOMBRE
ORDER BY SUM(GJ.GOLES) DESC
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

   e) Supongamos que creamos una View llamada 
      POSICION(EQUIPO,TOTAL_PUNTOS), la cual me devuelve la 
      tabla de posiciones de los equipos del Mundial (tal como
      se resolvi en MunQry.sql), basndose en esta View: 
      Cul es la diferencia de puntos entre ARGENTINA y BRASIL?
      
*/

CREATE OR REPLACE VIEW POSICION(EQUIPO,TOTAL_PUNTOS)
AS
SELECT PEQ.EQUIPO "EQUIPO",SUM(PEQ.PUNTOS)  FROM (
SELECT PV.NOMBRE_EQ1 "EQUIPO",(COUNT(PV.FECHA)*3) "PUNTOS" FROM PARTIDOV PV
WHERE PV.RESULTADO = 'L'
GROUP BY PV.NOMBRE_EQ1
UNION
SELECT PV.NOMBRE_EQ2 "EQUIPO",(COUNT(PV.FECHA)*3) "PUNTOS" FROM PARTIDOV PV
WHERE PV.RESULTADO = 'V'
GROUP BY PV.NOMBRE_EQ2
UNION
SELECT PV.NOMBRE_EQ1 "EQUIPO",COUNT(PV.FECHA) "PUNTOS" FROM PARTIDOV PV
WHERE PV.RESULTADO = 'E'
GROUP BY PV.NOMBRE_EQ1
UNION
SELECT PV.NOMBRE_EQ2 "EQUIPO",COUNT(PV.FECHA) "PUNTOS" FROM PARTIDOV PV
WHERE PV.RESULTADO = 'E'
GROUP BY PV.NOMBRE_EQ2
UNION
SELECT PV.NOMBRE_EQ1 "EQUIPO",0 "PUNTOS" FROM PARTIDOV PV
WHERE PV.RESULTADO = 'V'
GROUP BY PV.NOMBRE_EQ1
UNION
SELECT PV.NOMBRE_EQ2 "EQUIPO",0 "PUNTOS" FROM PARTIDOV PV
WHERE PV.RESULTADO = 'L'
GROUP BY PV.NOMBRE_EQ2
) PEQ
GROUP BY PEQ.EQUIPO
/

SELECT (VP1.TOTAL_PUNTOS - VP2.TOTAL_PUNTOS) "DIF. ARG - BRA"
FROM POSICION VP1, POSICION VP2
WHERE VP1.EQUIPO = 'ARGENTINA' AND VP2.EQUIPO = 'BRASIL'
/

/*
Crear store procedure para resolver diferencia de puntos entre equipos
*/
CREATE OR REPLACE PROCEDURE DIFPUNTOS(EQ1 IN EQUIPO.NOMBRE%TYPE,EQ2 IN EQUIPO.NOMBRE%TYPE,DIF OUT NUMBER)
AS
   PTSEQ1 NUMBER;
   PTSEQ2 NUMBER;
BEGIN
   SELECT TOTAL_PUNTOS INTO PTSEQ1 FROM POSICION WHERE EQUIPO = EQ1;
   SELECT TOTAL_PUNTOS INTO PTSEQ2 FROM POSICION WHERE EQUIPO = EQ2;
   DIF := PTSEQ1 - PTSEQ2;
   DBMS_OUTPUT.PUT_LINE('DIFERENCIA ENTRE ' || EQ1 || ' ' || EQ2 || ' ' || TO_CHAR(DIF) );
EXCEPTION
   WHEN NO_DATA_FOUND THEN
       raise_application_error(-20400,'Equipo no encontrado');
END;
/

CREATE OR REPLACE PROCEDURE EXDIFPUNTOS
AS
    DIFERENCIA NUMBER;
BEGIN
    DIFPUNTOS('ARGENTINA','BRASIL',DIFERENCIA);
    DBMS_OUTPUT.PUT_LINE('DIFERENCIA=' || TO_CHAR(DIFERENCIA) );
END;
/



SPOOL OFF