spool MunPar2
/* 

Autor: Lic. Guillermo Cherencio

Implementacion DER
Programacion Aplicacion
Universidad Nacional de Lujan

Forma de uso:

SQL> start <path>\MunPar2.sql   (antes ejecutar Mundial.sql,Mundial2.sql,MunDat.sql,MunQry.sql)

Algunos Queries y procesos tipicos sobre
la Implementacion del enunciado DER del Mundial de Futbol
RESPUESTAS 2DO. PARCIAL 2002

Formato Gral. de este script:

<< SETEOS DE AMBIENTE/PARAMETROS REQUERIDOS PARA LA EJECUCION >>

<< EJECUTO QUERIES >>


En MunPar2.lst queda la salida de este script.

*/

/* Sets para la sesion actual */
clear buffer
set serveroutput on
set verify off
set termout on
ALTER SESSION SET NLS_DATE_FORMAT = 'dd/mm/yyyy'
/

DROP PROCEDURE BAJAPAR
/
DROP VIEW PROMXEQ
/
DROP VIEW GOLXEQ
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

1) Cul fue o cules fueron los partidos que comenzaron ms tarde? Es decir, que tuvieron la hora de finalizacin ms tarda.      
*/

SELECT * FROM PARTIDO
WHERE HORA_FIN = ( SELECT MAX(HORA_FIN)
                      FROM PARTIDO )
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

2) Cul fue el promedio de goles por equipo?
Creo una View con el total de goles por equipo
Creo una View con el promedio de goles x equipo 
para luego reutilizarla en el siguiente query
*/

CREATE OR REPLACE VIEW GOLXEQ(EQUIPO,TGOLES) AS
SELECT PAR.NOMBRE_EQ1 "EQUIPO", SUM(PJ.GOLES) "TGOLES"
       FROM PARTIDO PAR, PAR_JUG PJ, JUGADOR JG
       WHERE PAR.FECHA = PJ.FECHA AND
             PAR.NOMBRE_EQ1 = PJ.NOMBRE_EQ1 AND
             PJ.NOMBRE = JG.NOMBRE AND
             PAR.NOMBRE_EQ1 = JG.NOMBRE_EQ
       GROUP BY PAR.NOMBRE_EQ1
       UNION
       SELECT PAR.NOMBRE_EQ2 "EQUIPO", SUM(PJ.GOLES) "TGOLES"
       FROM PARTIDO PAR, PAR_JUG PJ, JUGADOR JG
       WHERE PAR.FECHA = PJ.FECHA AND
             PAR.NOMBRE_EQ1 = PJ.NOMBRE_EQ1 AND
             PJ.NOMBRE = JG.NOMBRE AND
             PAR.NOMBRE_EQ2 = JG.NOMBRE_EQ
       GROUP BY PAR.NOMBRE_EQ2
/

CREATE OR REPLACE VIEW PROMXEQ(EQUIPO,PROMEDIO) AS
SELECT GOL.EQUIPO "EQUIPO",AVG(GOL.TGOLES) "PROMEDIO"
FROM GOLXEQ GOL
GROUP BY GOL.EQUIPO
/

/*
SQL.  Sobre el ya famoso Mundial de Ftbol, 
      implementar las siguientes consultas:

3) En cul o cules partidos un equipo hizo ms goles que su promedio de goles?
Reutilizo las Views creadas anteriormente
*/
SELECT P.FECHA,P.NOMBRE_EQ1,P.NOMBRE_EQ2
FROM PARTIDO P, PROMXEQ PR1, PROMXEQ PR2, GOLXEQ GOLXEQ1, GOLXEQ GOLXEQ2
WHERE (P.NOMBRE_EQ1 = GOLXEQ1.EQUIPO AND P.NOMBRE_EQ1 = PR1.EQUIPO AND GOLXEQ1.TGOLES > PR1.PROMEDIO) OR (P.NOMBRE_EQ2 = GOLXEQ2.EQUIPO AND P.NOMBRE_EQ2 = PR2.EQUIPO AND GOLXEQ2.TGOLES > PR2.PROMEDIO)
/


/*
8) Sobre el Mundial de Futbol, desarrolle el siguiente procedimiento en pl/sql que reciba como parametro de entrada una fecha.  Su objetivo ser dar de baja todos los partidos que posean una fecha <= al parametro de entrada.  Tener en cuenta que la tabla partido no tiene activado el borrado en cascada.
*/
CREATE OR REPLACE PROCEDURE BAJAPAR(PFECHA IN PARTIDO.FECHA%TYPE)
AS
   n_par NUMBER;
BEGIN
   SELECT COUNT(*) INTO n_par FROM PARTIDO WHERE FECHA <= PFECHA;
   IF n_par = 0 THEN
      raise_application_error(-20400,'No hay Partidos con Fecha <= a ' 
         || to_char(PFECHA) );
   END IF;
   DELETE FROM PAR_JUG WHERE FECHA <= PFECHA;
   DELETE FROM PARTIDO WHERE FECHA <= PFECHA;
END;
/

SPOOL OFF